
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>《Windows网络与通信程序设计（第3版）》——2.4　网络对时程序实例 / iVAN</title>

    <meta name="description" content="《Windows网络与通信程序设计（第3版）》——2.4　网络对时程序实例 2.4 网络对时程序实例 网络对时也就是从Internet上获得准确的时间,以此来校对本地计算机时钟.通过这样一个实例程序,大家可以初步了解协议和Winsock函数的具体应用. ** 2.4.1 时间协议(Time Protocol)** Time Protocol (RFC-868)是一种非常简单的应用层协议.它返回一个未格式化的32位二进制数字,这个数字描述了从1900年1月1日午夜到现在的秒数.服务器在端口37监听时间协议请求,以TCP/IP或者UDP/IP格式返回响应.将服务器的返回值转">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">《Windows网络与通信程序设计（第3版）》——2.4　网络对时程序实例</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h3>2.4　网络对时程序实例</h3>
<p>网络对时也就是从Internet上获得准确的时间，以此来校对本地计算机时钟。通过这样一个实例程序，大家可以初步了解协议和Winsock函数的具体应用。<br />
**<br />
2.4.1　时间协议（Time Protocol）**<br />
Time Protocol （RFC-868）是一种非常简单的应用层协议。它返回一个未格式化的32位二进制数字，这个数字描述了从1900年1月1日午夜到现在的秒数。服务器在端口37监听时间协议请求，以TCP/IP或者UDP/IP格式返回响应。将服务器的返回值转化成本地时间是客户端程序的责任（进行转化时需要借用文件时间，详见后面的程序代码）。</p>
<p>下面是在传输层使用TCP的Time Protocol的工作过程（S代表服务器，C代表客户）。</p>
<p>S：监听端口37。<br />
C：连接到端口37。<br />
S：以32位二进制数发送时间。<br />
C：接收时间。<br />
C：关闭连接。<br />
S：关闭连接。<br />
如果服务器不能决定现在是什么时间，服务器会拒绝连接或不发送任何数据而直接关闭连接。<br />
**<br />
2.4.2　TCP/IP实现代码**<br />
下面是使用Time Protocol实现的基于TCP/IP的网络对时程序。程序运行后，自动使本地时间和时间服务器时间同步，这里使用的时间服务器是129.132.2.21，更多的服务器地址在“<a href="http://tf.nist.gov/service/time-servers.html%E2%80%9D%E7%BD%91%E7%AB%99%E5%88%97%E5%87%BA%EF%BC%88%E5%A6%82129.6.15.28%E3%80%81132.163.4.101%E7%AD%89%EF%BC%89%E3%80%82" rel="external nofollow noreferrer">http://tf.nist.gov/service/time-servers.html”网站列出（如129.6.15.28、132.163.4.101等）。</a></p>
<pre><code>#include "../common/InitSock.h"                      // NetTime工程下
#include &lt;stdio.h&gt;
CInitSock initSock;
void SetTimeFromTP(ULONG ulTime)          // 根据时间协议返回的时间设置系统时间
{
          // Windows文件时间是一个64位的值，它是从1601年1月1日中午12:00到现在的时间间隔，
          // 单位是1/1000 0000秒，即1000万分之1秒（100-nanosecond ）
          FILETIME ft;
          SYSTEMTIME st;
          // 首先将基准时间（1900年1月1日0点0分0秒0毫秒）转化为Windows文件时间
          st.wYear = 1900;
          st.wMonth = 1;
          st.wDay = 1;
          st.wHour = 0;
          st.wMinute = 0;
          st.wSecond = 0;
          st.wMilliseconds = 0;
          SystemTimeToFileTime(&amp;st, &amp;ft);
          // 然后将Time Protocol使用的基准时间加上以及逝去的时间，即ulTime
          LONGLONG *pLLong = (LONGLONG *)&amp;ft;
          // 注意，文件时间单位是1/1000 0000秒，即1000万分之1秒（100-nanosecond ）
          *pLLong += (LONGLONG)10000000 * ulTime;
          // 再将时间转化回来，更新系统时间
          FileTimeToSystemTime(&amp;ft, &amp;st);
          SetSystemTime(&amp;st);
}
int main()
{
          SOCKET s = ::socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
          if(s == INVALID_SOCKET)
          {
                    printf(" Failed socket() \n");
                    return 0;
          }
          // 填写远程地址信息，连接到时间服务器
          sockaddr_in servAddr;
          servAddr.sin_family = AF_INET;
          servAddr.sin_port = htons(37);
          // 这里使用的时间服务器是129.132.2.21，更多地址请参考http://tf.nist.gov/service/its.htm
          servAddr.sin_addr.S_un.S_addr = inet_addr("129.132.2.21");
          if(::connect(s, (sockaddr*)&amp;servAddr, sizeof(servAddr)) == -1)
          {
                    printf(" Failed connect() \n");
                    return 0;
          }
          // 等待接收时间协议返回的时间。学习了Winsock I/O模型之后，最好使用异步I/O，以便设置超时
          ULONG ulTime = 0;
          int nRecv = ::recv(s, (char*)&amp;ulTime, sizeof(ulTime), 0);
          if(nRecv &gt; 0)
          {
                    ulTime = ntohl(ulTime);
                    SetTimeFromTP(ulTime);
                    printf(" 成功与时间服务器的时间同步！\n");
          }
          else
          {
                    printf(" 时间服务器不能确定当前时间！\n");
          }
          ::closesocket(s);
          return 0;
}
</code></pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-18 09:15:53</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e4%ba%91%e6%a0%96%e7%a4%be%e5%8c%ba/" title="云栖社区">云栖社区</a>, <a href="https://www.iamivan.net/tag/%e5%90%8c%e6%ad%a5/" title="同步">同步</a>, <a href="https://www.iamivan.net/tag/%e6%9c%8d%e5%8a%a1%e5%99%a8/" title="服务器">服务器</a>, <a href="https://www.iamivan.net/tag/windows/" title="windows">windows</a>, <a href="https://www.iamivan.net/tag/socket/" title="socket">socket</a>, <a href="https://www.iamivan.net/tag/service/" title="service">service</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>《Windows网络与通信程序设计（第3版）》——2.4　网络对时程序实例的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxgYaOb.html" rel="bookmark">《Windows网络与通信程序设计（第3版）》&mdash;&mdash;1&period;4　网络应用程序设计基础</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.4 网络应用程序设计基础 本节讲述网络应用程序设计的原则和网络程序开发环境的设置. 1.4.1 网络程序体系结构在创建网络应用程序之前,首先要决定应用程序的体系结构.应用程序体系结构(application architecture)由应用程序开发者设计,它指定了在各种各样的终端系统上,应用程序是如何组织的.本节介绍现有的主要体系结构:客户机/服务器体系结构.P2P体系结构和这两种结构的混合. 1．客户机/服务器体系结构在客户机/服务器体系结构中,有一个总是在运行的主机,称为服务器,它为来自			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1rBnap.html" rel="bookmark">《Windows网络与通信程序设计（第3版）》&mdash;&mdash;2&period;3　Winsock编程详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.3 Winsock编程详解 使用TCP创建网络应用程序稍微复杂一些,因为TCP是面向连接的协议,需要通信双方首先建立一个连接.本节先以建立简单的TCP客户端和服务器端应用程序为例,详细说明Winsock的编程流程,然后再介绍较为简单的UDP编程. 2.3.1 Winsock编程流程 使用Winsock编程的一般步骤是比较固定的,可以结合后面的例子程序来理解它们. 1．套接字的创建和关闭 使用套接字之前,必须调用socket函数创建一个套接字对象,此函数调用成功将返回套接字句柄. SOCKET			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9NV7Vp.html" rel="bookmark">《Windows网络与通信程序设计（第3版）》&mdash;&mdash;第1章 计算机网络基础1&period;1　网络的概念和网络的组成</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第1章 计算机网络基础 本章详细讲述网络程序设计中要用到的计算机网络方面的基础知识,包括各种网络术语.网络硬件设备.网络拓扑结构.网络协议等. 1.1 网络的概念和网络的组成 网络是各种连在一起的可以相互通信的设备的集合.本书讲述的网络是最常见的,将数亿计算机连接到一起的Internet.下面通过讲述组成Internet的基本硬件和软件来进一步明确计算机网络的概念. Internet是世界范围内的计算机网络,它不仅连接了PC.存储和传输信息的服务器,还连接了PDA.电视.移动PC等.所有的这些设			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pX94nlz.html" rel="bookmark">《Windows网络与通信程序设计（第3版）》&mdash;&mdash;1&period;3　网络程序寻址方式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.3 网络程序寻址方式 编写网络程序,必须要有一种机制来标识通信的双方.本节详细讨论Internet中各层的寻址方式,以及相关的寻址协议. 1.3.1 MAC地址网络通信的最边缘便是LAN了,我们先来看看在LAN中是如何寻址的. 1．MAC子层和MAC地址LAN主要使用广播通信.在其内部,许多主机连在相同的通信通道上,通信时的关键问题是当竞争存在时如何决定谁使用通道.解决此问题的协议属于链路层的子层,称为MAC(Medium Access Control,介质访问控制)子层.MAC子层在LAN			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYdmY9b.html" rel="bookmark">《Windows网络与通信程序设计（第3版）》&mdash;&mdash;1&period;2　计算机网络参考模型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.2 计算机网络参考模型 了解网络的相关概念之后,本节将讨论计算机网络中主机之间是如何进行通信的,以及各种通信协议之间的关系等. 1.2.1 协议层次为了降低设计难度,大部分网络都以层(layer或level)的形式组织在一起,每一层都建立在它的下层之上,使用它的下层提供的服务,下层对它的上层隐藏了服务实现的细节.这种方法几乎应用于整个计算机科学领域,也可以称为信息隐藏.数据类型抽象.数据封装.面向对象编程等. 一个机器上的第n层和另一个机器的第n层交流,所使用的规则和协定合起来称为第n层协议			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAANlvM.html" rel="bookmark">《Windows网络与通信程序设计（第3版）》&mdash;&mdash;2&period;2　Winsock的寻址方式和字节顺序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.2 Winsock的寻址方式和字节顺序 本节讲述在Winsock中主机地址信息的表示方法,以及相关的操作函数. 2.2.1 Winsock寻址 因为Winsock要兼容多个协议,所以必须使用通用的寻址方式.TCP/IP使用IP地址和端口号来指定一个地址,但是其他协议也许采用不同的形式.如果Winsock强迫使用特定的寻址方式,添加其他协议就不大可能了.Winsock的第一个版本使用sockaddr结构来解决此问题. struct sockaddr { u_short sa_family; c			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MY58nxM.html" rel="bookmark">《Windows网络与通信程序设计（第3版）》&mdash;&mdash;第2章 Winsock编程接口2&period;1　Winsock库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第2章 Winsock编程接口 Winsock是Windows下网络编程的标准接口,它允许两个或多个应用程序在相同机器上,或者是通过网络相互交流.Winsock是真正的协议无关的接口,本章主要讲述如何使用它来编写应用层的网络应用程序. 2.1 Winsock库 Winsock库有两个版本,Winsock1和Winsock2.现在开发网络应用程序都使用Winsock2,需要在程序中包含头文件winsock2.h,它包含了绝大部分socket函数和相关结构类型的声明和定义.同时要添加的还有到WS2_			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mv7lD9p.html" rel="bookmark">《交互式程序设计 第2版》一3&period;8 程序的运行和调试</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				3.8 程序的运行和调试 编写好一个应用程序,单击运行按钮.程序输出如图3-8所示. 图3-8:运行一个Processing应用程序很简单,是不是?如果应用程序不能运行,会发生什么?看看图3-9的消息区. 图3-9:观察消息区上的错误提示注意这条消息,这很有用: The function printd(String) does not exist. 这条消息告诉你,想调用的方法printd()并不存在.Processing环境也会返回更深层的错误.例如,如果你在setup()方法中输入下列语句:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bK520Wp.html" rel="bookmark">Windows 8&period;1开发版泄露到网络上</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[科技讯]4月18日消息,昨天一款版本号为9369的Windows 8.1的开发版泄露到网络上,并通过一个私人Torrent站点公布了整个ISO文档.想必有部分喜欢尝鲜的用户已经动手安装了这个版本.如果你没有安装,而又好奇它有哪些变化的话,不妨点击观看下面的这个上手视频了解了解:      这个视频是由WinBeta发布的,展示了build 9369的一部分新功能,包括新的应用排序方式和新的PC Setting界面--虽然在之前的外泄版本上也有所曝光,但现在已经变得更好更简洁了.此外,你还会得到			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9ze9yOz.html" rel="bookmark" class="title">实例讲解配置之&mdash;&mdash;TOMCAT集群配置</a>
					<div>
						我的运行环境:Windows2003 Server SP4 + J2SDK1.5.0 +Tomcat5.5.9 准备软件:Tomcat 5.5.9   JDK1.5.0 一．配置过程 1.安装JDK1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7M0aZ0p.html" rel="bookmark" class="title">Linux 下 php 转DOC转PDF转SWF实现百度的文库预览功能</a>
					<div>
						去年开发了一个OA系统,需要实现文档一键上传并实现在线预览,类似百度文库的功能. 系统环境:CentOs5.5 用到的工具:Openoffice 3 , Pdf2Swf tool , Jodconve ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbEN5nM.html" rel="bookmark" class="title">PS实例教程&colon;朦胧灰色调的LOMO风格美女图片</a>
					<div>
						作者对Lomo风格有非常深入的了解,因此调色的时候非常轻松.不管在任何模式下都能快速调出好看的效果.Lomo风格图片并没有特殊的定义,调色的时候只需画面带有一种朦胧的灰调,有明显的暗角等即可.原图 最 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMy8ZJb.html" rel="bookmark" class="title">MS SQL Server查询优化方法&lpar;1&rpar;●查询速度慢的原因很多，常见如下几种：</a>
					<div>
						server|速度|优化 MS SQL Server查询优化方法(1) ●查询速度慢的原因很多,常见如下几种: 1.没有索引或者没有用到索引(这是查询慢最常见的问题,是程序设计的缺陷) 2.I/O吞吐 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPwnqM.html" rel="bookmark" class="title">Google修改隐私政策 整合多款产品用户信息</a>
					<div>
						1月25日消息,据国外媒体报道,Google将修改处理用户信息的方式,整合来自Gmail.Google+和YouTube等服务中的用户信息,使在一款服务中收集的信息可以应用在另一款服务中. 比如,如果 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPjdrz.html" rel="bookmark" class="title">501 Mail path must not include special characters问题</a>
					<div>
						最近,我们公司的MDaemon邮件服务器,往186邮箱发送邮件时报错&quot;501 Mail path must not include special characters&quot;,请看下面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze43e7p.html" rel="bookmark" class="title">python实现批量改文件名称的方法</a>
					<div>
						  本文实例讲述了python实现批量改文件名称的方法.分享给大家供大家参考.具体分析如下: 发现python中提供了大量的模块函数,有时候一些系统操作在python中非常简单 下面的文件关键是要放到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKPVVp.html" rel="bookmark" class="title">WPS演示中的荧笔光 教师教学的好帮手</a>
					<div>
						许多老师反映,在教学中他们总是在黑板.电脑.荧幕三处来回走动,浪费了很多时间和精力.WPS演示中的荧光笔解决了老师讲课的这个难题.它是集粉笔.激光笔.鼠标于一体的.它不仅可以把鼠标的颜色改变,还可以让 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP88eDp.html" rel="bookmark" class="title">PhotoShop影楼婚片后期场景合成与调色教程</a>
					<div>
						本PS 教程介绍PhotoShop给影楼婚片后期制作,包括场景合成和调色. 正确的学习调色方法,首先是认真解读Photoshop中有关色彩构成理论,先把色彩构成的理论基础打牢实了,再拿一些典型示范作练 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNj3WM.html" rel="bookmark" class="title">javascript 对象数组根据对象object key的值排序</a>
					<div>
						 本文仅仅是实现了javascript 对象数组根据对象object key的值排序,算是对自己学习javascript这么久的一个小结,希望大家能够喜欢     有个js对象数组 var ary=[ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5oY07b.html" rel="bookmark" class="title">win7系统某些软件无法联网使用如何修复</a>
					<div>
						  win7系统某些软件无法联网使用如何修复         具体方法如下: 1. 右键点击桌面的右下角网络小图标; 2. 单击打开网络和共享中心.在右上角有个更改适配器设置,在这里就可以看到网络连接 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z726XXp.html" rel="bookmark" class="title">Win7文件被360安全软件隔离恢复方法</a>
					<div>
						  使用Win7的小伙伴问小编,文件要是被360安全软件给隔离要怎么办,有什么恢复的方法吗,在这里小编就来传授一招给大家,希望能够帮助到大家. 步骤一:360杀毒 1.打开360杀毒,点击主界面左下角 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9EDYgM.html" rel="bookmark" class="title">BIOS中设置不同的开机方式</a>
					<div>
						  如何在BIOS中设置不同的开机方式呢? 在进入BIOS后,将光标移到Integrated Peripherals,并按[Enter]键,在界面中选择POWE ON Function并按[Enter ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8o7vp.html" rel="bookmark" class="title">sgid-求助：Linux权限设置的问题</a>
					<div>
						问题描述 求助:Linux权限设置的问题 root创建了一个目录:/srv/project,权限为770,拥有者为root,群组为pgroup 用户jack,是群组pgroup的成员,在/srv/pr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7KYoz.html" rel="bookmark" class="title">大家有没有java编程思想有点罗嗦？</a>
					<div>
						问题描述 有时候,一些本不复杂的问题,说的太多,而且不怎么善于总结.....东扯西拉,事实上,看此书的目录也是这样的感觉. 解决方案 解决方案二:很多书都喜欢讲大的概念,一堆新名词挂载嘴边实际上内容空 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7YWj5M.html" rel="bookmark" class="title">Confman - 分享一个「Node 应用」配置文件加载模块</a>
					<div>
						一句话介绍 Confman 是一个强大的配置文件加载器,无论你喜欢 yaml .cson.json.properties.plist.ini.toml.xml 还是 js,都能满足你的愿望,并且更加简 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9YBD4M.html" rel="bookmark" class="title">php中实现产品展示&dollar;classify&equals;array&lpar;&amp;amp&semi;amp&semi;quot&semi;&amp;amp&semi;amp&semi;quot&semi;&rpar;方法如何将产品介绍分类添加进txt文件中</a>
					<div>
						问题描述 php中实现产品展示$classify=array(&quot;&quot;)方法如何将产品介绍分类添加进txt文件中 已实现通过读取txt文档进行产品展示,如何跟据不同产品种类分类添加产品 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8kQRVM.html" rel="bookmark" class="title">Maven详解之------maven版本管理</a>
					<div>
						本文允许转载,但请标明出处:http://blog.csdn.net/wanghantong/article/38424065, 版权所有 现在所说的maven版本不同于SVN的版本控制哦!!! 之前 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boRGADz.html" rel="bookmark" class="title">《Visual C&num; 2010入门经典》一1&period;1 &period;NET Framework</a>
					<div>
						1.1 .NET Framework Visual C# 2010入门经典 .NET Framework提供了一些工具和技术,让开发人员能够以独立于语言和平台的方式创建并运行下一代应用程序和Web服务 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN7K7op.html" rel="bookmark" class="title">ado-vs2010 添加ADO&period;net 实体数据模型时错误</a>
					<div>
						问题描述 vs2010 添加ADO.net 实体数据模型时错误 本人学生菜鸟,学习 Entity Framework 的时候添加实体数据模型的时候,ADO实体模型是灰色的,添加后显示如下错误,求各位大 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxYdgQp.html" rel="bookmark" class="title">第三方登录-自己的应用实现微博第三方登陆问题，为什没人回答呢。。。</a>
					<div>
						问题描述 自己的应用实现微博第三方登陆问题,为什没人回答呢... 3C 新手....自己的应用能实现的是微博第三方登录.怎样改成点击微博第三方登录时每次都跳转到微博的登录界面而不管微博是否已经登录了微 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDeY6rb.html" rel="bookmark" class="title">ongetminmaxinfo-CSplitterWnd分割，在主窗口的OnGetMinMaxInfo中，不能重新设置行列的大小</a>
					<div>
						问题描述 CSplitterWnd分割,在主窗口的OnGetMinMaxInfo中,不能重新设置行列的大小 点击最大化按钮后,各个view的大小变了,我想在主窗口的OnGetMinMaxInfo中重新 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGEw5kM.html" rel="bookmark" class="title">ASP&period;NET开发中怎么实现多图片上传并浏览的功能</a>
					<div>
						问题描述 ASP.NET开发中怎么实现多图片上传并浏览的功能 ASP.NET开发中怎么实现多图片上传并浏览的功能,可以用什么控件来做? 解决方案 用jquery或者flash,自带的控件好像是不可以  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmKY8wb.html" rel="bookmark" class="title">jersey框架问题-jersey&commat;Produces类型转换问题</a>
					<div>
						问题描述 jersey@Produces类型转换问题 问题描述: @Produces(MediaType.APPLICATION_JSON) 报出 严重: Mapped exception to re ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRmkRp.html" rel="bookmark" class="title">郝二云：万里路桥鹏程万里</a>
					<div>
						-记鄂尔多斯市万里路桥有限公司董事长 郝二云 以科技为先导.以发展为宗旨.达到共同富裕,是鄂尔多斯市万里路桥有限责任公司发展的基本方针:与员工共荣.与企业共荣.与社会共荣是企业发展的理念:对社会负责. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZmW6z.html" rel="bookmark" class="title">mysql 5&period;7&period;9 免安装版配置方法图文教程&lowbar;Mysql</a>
					<div>
						小编把之前整理的关于mysql 5.7.9 免安装版配置方法分享给大家,供大家参考,具体内容如下 1. 解压MySQL压缩包 将下载的MySQL压缩包解压到自定义目录下,我的解压目录是: &quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MydYJZb.html" rel="bookmark" class="title">商业周刊：全球IT公司100强排行榜出炉</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 6月14日消息,&lt;商业周刊&gt;联手标准普尔,从收益规模在3亿美元以上的近500家IT公司中评出&quot;IT公司100强&quot;.Ame ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJqO8vp.html" rel="bookmark" class="title">谢谢指导-我现在在学习freemarker，能给我点帮助吗</a>
					<div>
						问题描述 我现在在学习freemarker,能给我点帮助吗 现在的问题是配置有问题,不能显示页 java.io.FileNotFoundException: Template /person.ftl  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVQrJnp.html" rel="bookmark" class="title">c&plus;&plus;-重载一个模板函数还是特例化，该如何选择？</a>
					<div>
						问题描述 重载一个模板函数还是特例化,该如何选择? 谢谢!~~~~~~~~~~~~~~~~~~~~~~~~~~~ 解决方案 看这个参数是否需要继续保持泛型.如果不需要,就特化. 解决方案二: 主要还是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2ZwvZb.html" rel="bookmark" class="title">PHP 面向对象详解&lowbar;php技巧</a>
					<div>
						对象的主要三个特性 对象的行为:可以对 对象施加那些操作,开灯,关灯就是行为. 对象的形态:当施加那些方法是对象如何响应,颜色,尺寸,外型. 对象的表示:对象的表示就相当于身份证,具体区分在相同的行为 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.025 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
